import 'dart:async';

/// Maps each element of elements by predicate
///  and joins result list via separator or empty string.
String mapAndJoin<T>(Iterable<T> elements, String predicate(T item),
        {String separator = ''}) =>
    elements.map(predicate).join(separator);

/// If `condition` is true, then returns `whenTrue`, else returns `orElse` or ''.
/// ( All arguments will be calculated. )
String ifThen(bool condition, String whenTrue, {String orElse = ''}) =>
    condition ? whenTrue : orElse ?? '';

/// If `condition` is true, then returns `whenTrue()`, else returns `orElse()` or ''.
/// ( All arguments will be calculated. )
String ifThenLazy(bool condition, FutureOr<String> Function() whenTrue,
        {FutureOr<String> Function() orElse}) =>
    condition ? whenTrue() : orElse != null ? orElse() : '';
